
function efgf_base_animation()
return

  {    filename = "__Earth-federation__/graphics/entity/efgf-base/efgf-base.png",    line_length = 1,    width = 224,    height = 224,    frame_count = 1,    animation_speed = 0.18,    direction_count = 1,    run_mode = "forward-then-backward",    shift = {0, 0}  }
end


function efgf_infantry_runanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/efgf-infantry/efgf-infantry_run.png",

    width = 200,    height = 200,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function efgf_infantry_attackanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/efgf-infantry/efgf-infantry_attack.png",

    width = 200,    height = 200,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function type61_mbt_runanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/type61-mbt/type61-mbt.png",

    width = 200,    height = 200,    line_length = 8,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function type61_mbt_attackanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/type61-mbt/type61-mbt.png",

    width = 200,    height = 200,    line_length = 8,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function gm_runanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/gm/gm_run.png",

    width = 200,    height = 200,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function gm_attackanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/gm/gm_attack.png",

    width = 200,    height = 200,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function white_base_runanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/white-base/white-base_run.png",

    width = 200,    height = 200,    line_length = 8,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function white_base_attackanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/white-base/white-base_attack.png",

    width = 200,    height = 200,    line_length = 8,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function gundam_runanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/gundam/gundam_run.png",

    width = 200,    height = 200,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function gundam_attackanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/gundam/gundam_attack.png",

    width = 200,    height = 200,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function guncannon_runanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/guncannon/guncannon_run.png",

    width = 200,    height = 200,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function guncannon_attackanimation(s)
  return

  {    filename = "__Earth-federation__/graphics/entity/guncannon/guncannon_attack.png",

    width = 200,    height = 200,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function guntank_runanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/guntank/guntank.png",

    width = 200,    height = 200,    line_length = 8,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function guntank_attackanimation()
  return

  {    filename = "__Earth-federation__/graphics/entity/guntank/guntank.png",

    width = 200,    height = 200,    line_length = 8,    frame_count = 1,    direction_count = 8,    shift = {0, 0}  }
end


function efaf_base_extension(inputs)
return

  {    filename = "__Mobile-suit__/graphics/entity/dummy.png",
  priority = "medium",
  width = 1,
  height = 1,
  direction_count = 4,
  frame_count = inputs.frame_count and inputs.frame_count or 5,
  line_length = inputs.line_length and inputs.line_length or 0,
  run_mode = inputs.run_mode and inputs.run_mode or "forward",
  shift = {0, 0},
  axially_symmetrical = false  }
end


function efaf_base_attack(inputs)
return

  {
  layers =

    {

      {
      width = 1,
      height = 1,
      frame_count = inputs.frame_count and inputs.frame_count or 2,
      axially_symmetrical = false,
      direction_count = 64,
      shift = {0, -1.25},

        stripes =

        {
          {
          filename = "__Mobile-suit__/graphics/entity/dummy.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 32,
        },

          {
          filename = "__Mobile-suit__/graphics/entity/dummy.png",
          width_in_frames = inputs.frame_count and inputs.frame_count or 2,
          height_in_frames = 32,
        }

        }
      }

    }

  }
end


data:extend
(
{

  {
    type = "unit-spawner",

    name = "efgf-base",

    icon = "__Earth-federation__/graphics/icons/efgf-base.png",

    flags = {"placeable-enemy", "breaths-air", "not-repairable"},

    max_health = 10000,

    healing_per_tick = 1,

    subgroup="enemies",

    order="b-b-h",

    resistances =

    {
      {
        type = "physical",
        decrease = 10,
        percent = 50
      },

      {
        type = "impact",
        decrease = 50,
        percent = 60
      },

      {
        type = "poison",
        decrease = 10,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 10,
        percent = 50
      },

      {
        type = "fire",
        decrease = 10,
        percent = 50
      },

      {
        type = "laser",
        decrease = 10,
        percent = 50
      }
,
      {
        type = "acid",
        decrease = 10,
        percent = 50
      },

      {
        type = "electric",
        decrease = 10,
        percent = 50
      }

    },

    working_sound = {
      sound =
      {
        {
          filename = "__base__/sound/creatures/spawner.ogg",
          volume = 1.0
        }
      },
      apparent_volume = 2
    },

    dying_sound =
    {
      {
        filename = "__base__/sound/creatures/spawner-death-1.ogg",
        volume = 1.0
      },
      {
        filename = "__base__/sound/creatures/spawner-death-2.ogg",
        volume = 1.0
      }
    },

    collision_box = {{-2.2, -2.2}, {2.2, 2.2}},

    selection_box = {{-2.5, -2.5}, {2.5, 2.5}},

    -- in ticks per 1 pu

    pollution_absorbtion_absolute = 20,

    pollution_absorbtion_proportional = 0.01,

    pollution_to_enhance_spawning = 30000,

    corpse = "big-remnants",

    dying_explosion = "big-explosion",

    loot =
    {
      {
        count_max = 1,
        count_min = 1,
        item = "zeon-military-medal-II",
        probability = 1
      }
    },

    max_count_of_owned_units = 10,

    max_friends_around_to_spawn = 5,

    animations =
    {
      efgf_base_animation()    },

    result_units = (function()

                     local res = {}

                       res[1] = {"efgf-infantry", {{0.0, 1.0}, {0.3, 0.5}, {0.9, 0.1}}}
                     if not data.is_demo then
                       -- from evolution_factor 0.3 the weight for medium-biter is linearly rising from 0 to 0.3
                       -- this means for example that when the evolution_factor is 0.45 the probability of spawning
                       -- a small biter is 66% while probability for medium biter is 33%.

                       res[2] = {"type61-mbt", {{0.29, 0.0}, {0.3, 0.5}, {0.9, 0.5}, {1.0, 0.1}}}
                       -- for evolution factor of 1 the spawning probabilities are: small-biter 0%, medium-biter 1/7, big-biter 4/7, behemoth biter 3/7

                       res[3] = {"gm", {{0.89, 0.0}, {0.9, 0.4}, {1.0, 0.4}}}
                       res[4] = {"white-base", {{0.99, 0.0}, {1.0, 0.1}}}

                       res[5] = {"gundam", {{0.99, 0.0}, {1.0, 0.1}}}

                       res[6] = {"guncannon", {{0.99, 0.0}, {1.0, 0.1}}}

                       res[7] = {"guntank", {{0.99, 0.0}, {1.0, 0.1}}}

                     end
                     return res
                   end)(),
    -- With zero evolution the spawn rate is 6 seconds, with max evolution it is 2.5 seconds
    spawning_cooldown = {360, 150},

    spawning_radius = 10,

    spawning_spacing = 3,
    max_spawn_shift = 0,

    max_richness_for_spawn_shift = 100,

    autoplace =
    {

      sharpness = 0.4,
      control = "enemy-base",

      order = "b[enemy]-c[efgf-base]",

      richness_multiplier = 1,

      richness_base = 0,

      force = "enemy",

      peaks =

      {

        {

          influence = 0,
          richness_influence = 100,

          tier_from_start_optimal = 20,

          tier_from_start_top_property_limit = 20,

          tier_from_start_max_range = 40,

        },

        {

          influence = -10.0,

          starting_area_weight_optimal = 1,

          starting_area_weight_range = 0,

          starting_area_weight_max_range = 2,

        },

        {

          influence = 0.425,

          noise_layer = "enemy-base",

          noise_octaves_difference = -1.8,

          noise_persistence = 0.5,

        },
        -- increase the size when moving further away

        {

          influence = 0.5,

          noise_layer = "enemy-base",

          noise_octaves_difference = -1.8,

          noise_persistence = 0.5,
          tier_from_start_optimal = 20,

          tier_from_start_top_property_limit = 20,

          tier_from_start_max_range = 40,

        },

      }
    },
    call_for_help_radius = 40
  },



  {

    type = "unit",

    name = "efgf-infantry",

    order="b-b-d",

    icon = "__Earth-federation__/graphics/icons/efgf-infantry.png",

    flags = {"placeable-enemy", "placeable-off-grid", "breaths-air", "not-repairable"},

    max_health = 2000,

    healing_per_tick = 1,

    subgroup="enemies",

    resistances =
    {

      {
        type = "physical",
        decrease = 10,
        percent = 40
      },

      {
        type = "poison",
        decrease = 10,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 20,
        percent = 50
      },
      {
        type = "acid",
        decrease = 10,
        percent = 40
      }

    },

    spawning_time_modifier = 8,

    healing_per_tick = 0.1,

    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},

    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},

    sticker_box = {{-0.5, -0.5}, {0.5, 0.5}},

    distraction_cooldown = 300,

    attack_parameters =
    {
      type = "projectile",

      ammo_category = "ef-ammo",

      cooldown = 2,

      range = 17,

      movement_slow_down_factor = 0.7,

      projectile_creation_distance = 1.125,

      projectile_center = {0.0625, -0.0875},
      damage_modifier = 2.2,

      shell_particle =

      {

        name = "shell-particle",

        direction_deviation = 0.1,

        speed = 0.1,

        speed_deviation = 0.03,

        center = {0, 0.1},

        creation_distance = -0.5,

        starting_frame_speed = 0.4,

        starting_frame_speed_deviation = 0.1

      },

      ammo_type =

      {

        category = "ef-ammo",

  
      action =

        {

          type = "direct",

          action_delivery =

          {

            type = "instant",

            source_effects =

            {

                type = "create-explosion",

                entity_name = "explosion-gunshot"

            },

            target_effects =

            {

              {

                type = "create-entity",

                entity_name = "explosion-hit"

              },

              {

                type = "damage",

                damage = { amount = 5 , type = "physical"}

              }

            }

          }

        }

      },
      sound = make_light_gunshot_sounds(),

      animation = efgf_infantry_attackanimation()

    },

    vision_distance = 30,

    movement_speed = 0.2,

    distance_per_frame = 0.2,

    -- in pu
    pollution_to_join_attack = 20000,

    corpse = "small-remnants",
    dying_explosion = "blood-explosion-small",

    working_sound = make_biter_calls(1.2),

    dying_sound = make_biter_dying_sounds(1.0),

    run_animation = efgf_infantry_runanimation()

  },


  {

    type = "unit",

    name = "type61-mbt",

    order="b-b-d",

    icon = "__Earth-federation__/graphics/icons/type61-mbt.png",

    flags = {"placeable-enemy", "placeable-off-grid", "breaths-air", "not-repairable"},

    max_health = 5000,

    healing_per_tick = 1,

    subgroup="enemies",

    resistances =
    {

      {
        type = "physical",
        decrease = 30,
        percent = 50
      },

      {
        type = "impact",
        decrease = 50,
        percent = 60
      },

      {
        type = "poison",
        decrease = 20,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 30,
        percent = 50
      },

      {
        type = "fire",
        decrease = 10,
        percent = 40
      },

      {
        type = "laser",
        decrease = 10,
        percent = 40
      }
,
      {
        type = "acid",
        decrease = 10,
        percent = 40
      }

    },

    spawning_time_modifier = 8,

    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},

    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},

    sticker_box = {{-0.5, -0.5}, {0.5, 0.5}},

    distraction_cooldown = 300,

    attack_parameters =
    {
      type = "projectile",

      ammo_category = "ef-ammo",

      cooldown = 40,

      range = 25,

      movement_slow_down_factor = 0,

      projectile_creation_distance = 1.6,

      projectile_center = {-0.15625, -0.07812},

      damage_modifier = 2,

      shell_particle =

      {

        name = "shell-particle",

        direction_deviation = 0.1,

        speed = 0.1,

        speed_deviation = 0.03,

        center = {0, 0.1},

        creation_distance = -0.5,

        starting_frame_speed = 0.4,

        starting_frame_speed_deviation = 0.1

      },

      ammo_type =

      {

        category = "ef-ammo",

  
      action =

        {

          type = "direct",

          action_delivery =

          {

            type = "projectile",

            projectile = "ef-cannon-projectile",

            starting_speed = 1,

            max_range = 30,

            source_effects =

            {

              type = "create-explosion",

              entity_name = "explosion-gunshot"

            }

          }

        }

      },
      sound =       {        filename = "__base__/sound/fight/tank-cannon.ogg",        volume = 1.0      }
,

      animation = type61_mbt_attackanimation()

    },

    vision_distance = 30,

    movement_speed = 0.25,

    distance_per_frame = 0.2,

    -- in pu
    pollution_to_join_attack = 20000,

    corpse = "medium-remnants",
    dying_explosion = "medium-explosion",

    working_sound = make_biter_calls(1.2),

    dying_sound = make_biter_dying_sounds(1.0),

    run_animation = type61_mbt_runanimation()

  },


  {

    type = "unit",

    name = "gm",

    order="b-b-d",

    icon = "__Earth-federation__/graphics/icons/gm.png",

    flags = {"placeable-enemy", "placeable-off-grid", "breaths-air", "not-repairable"},

    max_health = 5000,

    healing_per_tick = 1,

    subgroup="enemies",

    resistances =
    {

      {
        type = "physical",
        decrease = 30,
        percent = 50
      },

      {
        type = "impact",
        decrease = 50,
        percent = 60
      },

      {
        type = "poison",
        decrease = 20,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 30,
        percent = 50
      },

      {
        type = "fire",
        decrease = 10,
        percent = 40
      },

      {
        type = "laser",
        decrease = 10,
        percent = 40
      }
,
      {
        type = "acid",
        decrease = 10,
        percent = 40
      }
,

      {
        type = "electric",
        decrease = 10,
        percent = 40
      }

    },

    spawning_time_modifier = 8,

    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},

    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},

    sticker_box = {{-0.5, -0.5}, {0.5, 0.5}},

    distraction_cooldown = 300,

    attack_parameters =
    {
      type = "beam",

      ammo_category = "ef-ammo",

      damage_modifier = 20,

      cooldown = 60,

      range = 25,

      ammo_type =

      {

        category = "ef-ammo",

        action =

        {

          type = "direct",

          action_delivery =

          {

            type = "beam",

            beam = "Diffusion-Mega-particle-Cannon-beam",

            max_length = 25,

            duration = 60 * 2,

            source_offset = {0.15, -0.5},

          }

        }

      },
      sound =       {        filename = "__base__/sound/fight/electric-beam.ogg",        volume = 1.0      }
,

      animation = gm_attackanimation()

    },

    vision_distance = 30,

    movement_speed = 0.3,

    distance_per_frame = 0.2,

    -- in pu
    pollution_to_join_attack = 20000,

    corpse = "medium-remnants",
    dying_explosion = "medium-explosion",

    working_sound = make_biter_calls(1.2),

    dying_sound = make_biter_dying_sounds(1.0),

    run_animation = gm_runanimation()

  },


  {

    type = "unit",

    name = "white-base",

    order="b-b-d",

    icon = "__Earth-federation__/graphics/icons/white-base.png",

    flags = {"placeable-enemy", "placeable-off-grid", "not-on-map", "breaths-air", "not-repairable"},

    max_health = 10000,

    healing_per_tick = 10,

    subgroup="enemies",

    resistances =
    {

      {
        type = "physical",
        decrease = 50,
        percent = 50
      },

      {
        type = "impact",
        decrease = 50,
        percent = 60
      },

      {
        type = "poison",
        decrease = 20,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 30,
        percent = 50
      },

      {
        type = "fire",
        decrease = 10,
        percent = 50
      },

      {
        type = "laser",
        decrease = 10,
        percent = 50
      }
,
      {
        type = "acid",
        decrease = 10,
        percent = 50
      }
,

      {
        type = "electric",
        decrease = 10,
        percent = 50
      }

    },

    spawning_time_modifier = 8,

    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},

    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},

    sticker_box = {{-0.5, -0.5}, {0.5, 0.5}},

    distraction_cooldown = 300,

    attack_parameters =

    {

      type = "projectile",

      ammo_category = "ef-ammo",

      cooldown = 600,

      projectile_center = {0.53125, 1.5},

      projectile_creation_distance = 0.6,

      range = 60,

      ammo_type =

      {

        category = "ef-ammo",

        speed = 1,

        action =

        {

          type = "direct",

          action_delivery =

          {

            type = "projectile",

            projectile = "white-base-projectile",

            starting_speed = 0.28

          }

        }

      },
      sound = make_light_gunshot_sounds(),

      animation = white_base_attackanimation()

    },

    vision_distance = 30,

    movement_speed = 0.1,

    distance_per_frame = 0.2,

    -- in pu
    pollution_to_join_attack = 20000,

    corpse = "big-remnants",
    dying_explosion = "big-explosion",

    working_sound = make_biter_calls(1.2),

    dying_sound = make_biter_dying_sounds(1.0),

    run_animation = white_base_runanimation()

  },

  {

    type = "combat-robot",

    name = "core-booster",
    icon = "__Earth-federation__/graphics/icons/core-booster.png",
    flags = {"placeable-enemy", "placeable-off-grid", "not-on-map", "not-repairable"},

    subgroup="capsule",

    order="e-a-c",

    max_health = 1000,

    resistances =

    {

      {
        type = "physical",
        decrease = 30,
        percent = 40
      },

      {
        type = "poison",
        percent = 100
      },

      {
        type = "explosion",
        decrease = 20,
        percent = 40
      },

      {
        type = "fire",
        percent = 100
      },

      {
        type = "laser",
        decrease = 10,
        percent = 50
      }
,
      {
        type = "acid",
        percent = 100
      }
,

      {
        type = "electric",
        decrease = 10,
        percent = 50
      }

    },

    alert_when_damaged = false,

    collision_box = {{0, 0}, {0, 0}},

    selection_box = {{-0.5, -0.5}, {0.5, -0.5}},

    distance_per_frame = 0.13,

    time_to_live = 60 * 60 * 2,

    speed = 0.7,
    follows_player = true,

    friction = 0.01,
    range_from_player = 30.0,

    destroy_action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        source_effects =
        {
            type = "create-entity",
            entity_name = "explosion"
        }
      }
    },

    attack_parameters =

    {
      type = "beam",

      ammo_category = "ef-ammo",

      damage_modifier = 50,

      cooldown = 60,

      range = 30,

      ammo_type =

      {

        category = "ef-ammo",

        action =

        {

          type = "direct",

          action_delivery =

          {

            type = "beam",

            beam = "Diffusion-Mega-particle-Cannon-beam",

            max_length = 30,

            duration = 60 * 2,

            source_offset = {0.15, -0.5},

          }

        }

      },
      sound =       {        filename = "__base__/sound/fight/electric-beam.ogg",        volume = 1.0      }
,

    },

    idle =
    {      filename = "__Earth-federation__/graphics/entity/core-booster/core-booster.png",      priority = "high",      line_length = 8,      width = 200,      height = 200,      frame_count = 1,      direction_count = 8,      shift = {0, 0}    },

    shadow_idle =
    {
      filename = "__Mobile-suit__/graphics/entity/dummy.png",
      priority = "high",
      line_length = 8,
      width = 1,
      height = 1,
      frame_count = 1,
      direction_count = 8,
      shift = {0, 0}
    },

    in_motion =
    {      filename = "__Earth-federation__/graphics/entity/core-booster/core-booster.png",      priority = "high",      line_length = 8,      width = 200,      height = 200,      frame_count = 1,      direction_count = 8,      shift = {0, 0}    },

    shadow_in_motion =
    {
      filename = "__Mobile-suit__/graphics/entity/dummy.png",
      priority = "high",
      line_length = 8,
      width = 1,
      height = 1,
      frame_count = 1,
      direction_count = 8,
      shift = {0, 0}
    }
  },

  {

    type = "unit",

    name = "gundam",

    order="b-b-d",

    icon = "__Earth-federation__/graphics/icons/gundam.png",

    flags = {"placeable-enemy", "placeable-off-grid", "breaths-air", "not-repairable"},

    max_health = 10000,

    healing_per_tick = 10,

    subgroup="enemies",

    resistances =
    {

      {
        type = "physical",
        decrease = 50,
        percent = 50
      },

      {
        type = "impact",
        decrease = 50,
        percent = 60
      },

      {
        type = "poison",
        decrease = 20,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 30,
        percent = 50
      },

      {
        type = "fire",
        decrease = 10,
        percent = 50
      },

      {
        type = "laser",
        decrease = 10,
        percent = 50
      }
,
      {
        type = "acid",
        decrease = 10,
        percent = 50
      }
,

      {
        type = "electric",
        decrease = 10,
        percent = 50
      }

    },

    spawning_time_modifier = 8,

    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},

    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},

    sticker_box = {{-0.5, -0.5}, {0.5, 0.5}},

    distraction_cooldown = 300,

    attack_parameters =
    {
      type = "beam",

      ammo_category = "ef-ammo",

      damage_modifier = 50,

      cooldown = 60,

      range = 30,

      ammo_type =

      {

        category = "ef-ammo",

        action =

        {

          type = "direct",

          action_delivery =

          {

            type = "beam",

            beam = "Diffusion-Mega-particle-Cannon-beam",

            max_length = 30,

            duration = 60 * 2,

            source_offset = {0.15, -0.5},

          }

        }

      },
      sound =       {        filename = "__base__/sound/fight/electric-beam.ogg",        volume = 1.0      }
,

      animation = gundam_attackanimation()

    },

    vision_distance = 30,

    movement_speed = 0.4,

    distance_per_frame = 0.2,

    -- in pu
    pollution_to_join_attack = 20000,

    corpse = "big-remnants",
    dying_explosion = "big-explosion",

    working_sound = make_biter_calls(1.2),

    dying_sound = make_biter_dying_sounds(1.0),

    run_animation = gundam_runanimation()

  },


  {

    type = "unit",

    name = "guncannon",

    order="b-b-d",

    icon = "__Earth-federation__/graphics/icons/guncannon.png",

    flags = {"placeable-enemy", "placeable-off-grid", "breaths-air", "not-repairable"},

    max_health = 10000,

    healing_per_tick = 10,

    subgroup="enemies",

    resistances =
    {

      {
        type = "physical",
        decrease = 50,
        percent = 50
      },

      {
        type = "impact",
        decrease = 50,
        percent = 60
      },

      {
        type = "poison",
        decrease = 20,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 30,
        percent = 50
      },

      {
        type = "fire",
        decrease = 10,
        percent = 50
      },

      {
        type = "laser",
        decrease = 10,
        percent = 50
      }
,
      {
        type = "acid",
        decrease = 10,
        percent = 50
      }
,

      {
        type = "electric",
        decrease = 10,
        percent = 50
      }

    },

    spawning_time_modifier = 8,

    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},

    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},

    sticker_box = {{-0.5, -0.5}, {0.5, 0.5}},

    distraction_cooldown = 300,

    attack_parameters =
    {
      type = "projectile",

      ammo_category = "ef-ammo",

      cooldown = 60,

      range = 45,

      movement_slow_down_factor = 0,

      projectile_creation_distance = 1.6,

      projectile_center = {-0.15625, -0.07812},

      damage_modifier = 4,

      shell_particle =

      {

        name = "shell-particle",

        direction_deviation = 0.1,

        speed = 0.1,

        speed_deviation = 0.03,

        center = {0, 0.1},

        creation_distance = -0.5,

        starting_frame_speed = 0.4,

        starting_frame_speed_deviation = 0.1

      },

      ammo_type =

      {

        category = "ef-ammo",

  
      action =

        {

          type = "direct",

          action_delivery =

          {

            type = "projectile",

            projectile = "ef-cannon-projectile",

            starting_speed = 1,

            max_range = 45,

            source_effects =

            {

              type = "create-explosion",

              entity_name = "explosion-gunshot"

            }

          }

        }

      },
      sound =       {        filename = "__base__/sound/fight/tank-cannon.ogg",        volume = 1.0      }
,

      animation = guncannon_attackanimation()

    },

    vision_distance = 30,

    movement_speed = 0.25,

    distance_per_frame = 0.2,

    -- in pu
    pollution_to_join_attack = 20000,

    corpse = "big-remnants",
    dying_explosion = "big-explosion",

    working_sound = make_biter_calls(1.2),

    dying_sound = make_biter_dying_sounds(1.0),

    run_animation = guncannon_runanimation()

  },


  {

    type = "unit",

    name = "guntank",

    order="b-b-d",

    icon = "__Earth-federation__/graphics/icons/guntank.png",

    flags = {"placeable-enemy", "placeable-off-grid", "breaths-air", "not-repairable"},

    max_health = 5000,

    healing_per_tick = 10,

    subgroup="enemies",

    resistances =
    {

      {
        type = "physical",
        decrease = 50,
        percent = 50
      },

      {
        type = "impact",
        decrease = 50,
        percent = 60
      },

      {
        type = "poison",
        decrease = 20,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 30,
        percent = 50
      },

      {
        type = "fire",
        decrease = 10,
        percent = 50
      },

      {
        type = "laser",
        decrease = 10,
        percent = 50
      }
,
      {
        type = "acid",
        decrease = 10,
        percent = 50
      }
,

      {
        type = "electric",
        decrease = 10,
        percent = 50
      }

    },

    spawning_time_modifier = 8,

    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},

    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},

    sticker_box = {{-0.5, -0.5}, {0.5, 0.5}},

    distraction_cooldown = 300,

    attack_parameters =
    {
      type = "projectile",

      ammo_category = "ef-ammo",

      cooldown = 120,

      range = 60,

      movement_slow_down_factor = 0,

      projectile_creation_distance = 1.6,

      projectile_center = {-0.15625, -0.07812},

      damage_modifier = 6,

      shell_particle =

      {

        name = "shell-particle",

        direction_deviation = 0.1,

        speed = 0.1,

        speed_deviation = 0.03,

        center = {0, 0.1},

        creation_distance = -0.5,

        starting_frame_speed = 0.4,

        starting_frame_speed_deviation = 0.1

      },

      ammo_type =

      {

        category = "ef-ammo",

  
      action =

        {

          type = "direct",

          action_delivery =

          {

            type = "projectile",

            projectile = "ef-cannon-projectile",

            starting_speed = 1,

            max_range = 60,

            source_effects =

            {

              type = "create-explosion",

              entity_name = "explosion-gunshot"

            }

          }

        }

      },
      sound =       {        filename = "__base__/sound/fight/tank-cannon.ogg",        volume = 1.0      }
,

      animation = guntank_attackanimation()

    },

    vision_distance = 30,

    movement_speed = 0.2,

    distance_per_frame = 0.2,

    -- in pu
    pollution_to_join_attack = 20000,

    corpse = "big-remnants",
    dying_explosion = "big-explosion",

    working_sound = make_biter_calls(1.2),

    dying_sound = make_biter_dying_sounds(1.0),

    run_animation = guntank_runanimation()

  },

  {
    type = "turret",

    name = "efaf-base",

    icon = "__Earth-federation__/graphics/icons/efaf-base.png",

    flags = {"placeable-enemy", "not-repairable", "breaths-air"},

    max_health = 10000,

    healing_per_tick = 1,

    subgroup="enemies",

    order="b-b-f",

    resistances =

    {

      {
        type = "physical",
        decrease = 10,
        percent = 50
      },

      {
        type = "impact",
        decrease = 50,
        percent = 60
      },

      {
        type = "poison",
        decrease = 10,
        percent = 50
      },

      {
        type = "explosion",
        decrease = 10,
        percent = 50
      },

      {
        type = "fire",
        decrease = 10,
        percent = 50
      },

      {
        type = "laser",
        decrease = 10,
        percent = 50
      }
,
      {
        type = "acid",
        decrease = 10,
        percent = 50
      },

      {
        type = "electric",
        decrease = 10,
        percent = 50
      }

    },
    collision_box = {{-2.2, -2.2}, {2.2, 2.2}},

    selection_box = {{-2.5, -2.5}, {2.5, 2.5}},

    shooting_cursor_size = 4,

    rotation_speed = 1,

    corpse = "big-remnants",

    dying_explosion = "big-explosion",

    dying_sound = make_worm_dying_sounds(1.0),
    loot =
    {
      {
        count_max = 1,
        count_min = 1,
        item = "zeon-military-medal-II",
        probability = 1
      }
    },

    inventory_size = 2,

    folded_speed = 0.01,

    folded_animation = efaf_base_extension{frame_count=1, line_length = 1},
    prepare_range = 25,

    preparing_speed = 0.025,

    preparing_animation = efaf_base_extension{},
    prepared_speed = 0.015,

    prepared_animation = efaf_base_attack{frame_count=1},

    attacking_speed = 0.5,

    attacking_animation = efaf_base_attack{},

    folding_speed = 0.015,

    folding_animation = efaf_base_extension{run_mode = "backward"},
    base_picture =

    {

      filename = "__Earth-federation__/graphics/entity/efaf-base/efaf-base.png",

      priority = "high",

      width = 224,

      height = 224,

      frame_count = 1,
      axially_symmetrical = false,

      direction_count = 1,

      shift = {0, 0},

    },

    attack_parameters =

    {

      type = "projectile",

      ammo_category = "ef-ammo",

      cooldown = 600,

      projectile_center = {0.53125, 1.5},

      projectile_creation_distance = 0.6,

      range = 60,

      ammo_type =

      {

        category = "ef-ammo",

        speed = 1,

        action =

        {

          type = "direct",

          action_delivery =

          {

            type = "projectile",

            projectile = "efaf-base-projectile",

            starting_speed = 0.28

          }

        }

      },
      sound = make_light_gunshot_sounds(),

    },
    autoplace =

    {
      sharpness = 0.3,

      control = "enemy-base",

      order = "b[enemy]-d[efaf-base]",
      force = "enemy",

      peaks =
      {

        {
          influence = -10.0,

          starting_area_weight_optimal = 1,

          starting_area_weight_range = 0,

          starting_area_weight_max_range = 2,

        },

        {

          influence = 0.2,

          noise_layer = "enemy-base",

          noise_octaves_difference = -1.8,

          noise_persistence = 0.5,

        },

        {

          influence = 0.4,

          noise_layer = "enemy-base",

          noise_octaves_difference = -1.8,

          noise_persistence = 0.5,
          tier_from_start_optimal = 10,

          tier_from_start_top_property_limit = 10,

          tier_from_start_max_range = 20,

        },

      }

    },
    call_for_help_radius = 40
  },

  {

    type = "combat-robot",

    name = "flymanta",
    icon = "__Earth-federation__/graphics/icons/flymanta.png",
    flags = {"placeable-enemy", "placeable-off-grid", "not-on-map", "not-repairable"},

    subgroup="capsule",

    order="e-a-c",

    max_health = 500,

    resistances =

    {

      {
        type = "physical",
        decrease = 10,
        percent = 40
      },

      {
        type = "poison",
        percent = 100
      },

      {
        type = "explosion",
        decrease = 10,
        percent = 40
      },

      {
        type = "fire",
        percent = 100
      },

      {
        type = "laser",
        decrease = 10,
        percent = 40
      }
,
      {
        type = "acid",
        percent = 100
      }

    },

    alert_when_damaged = false,

    collision_box = {{0, 0}, {0, 0}},

    selection_box = {{-0.5, -0.5}, {0.5, -0.5}},

    distance_per_frame = 0.13,

    time_to_live = 60 * 60 * 2,

    speed = 0.5,
    follows_player = true,

    friction = 0.01,
    range_from_player = 20.0,

    destroy_action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        source_effects =
        {
            type = "create-entity",
            entity_name = "explosion"
        }
      }
    },

    attack_parameters =

    {

      type = "projectile",

      ammo_category = "ef-ammo",

      cooldown = 60,
      range = 30,

      projectile_center = {0, -1},

      ammo_type =

      {

        category = "ef-ammo",

        target_type = "direction",

        action =

        {

          type = "direct",


          repeat_count = 6,
          action_delivery =

          {

            type = "projectile",

            projectile = "rocket",

            starting_speed = 0.1,

            source_effects =

            {

              type = "create-entity",

              entity_name = "explosion-hit"

            }

          }

        }

      },

      sound =      {        filename = "__base__/sound/fight/rocket-launcher.ogg",        volume = 0.7
      }

    },

    idle =
    {      filename = "__Earth-federation__/graphics/entity/flymanta/flymanta.png",      priority = "high",      line_length = 4,      width = 80,      height = 60,      frame_count = 1,      direction_count = 4,      shift = {0, 0}    },

    shadow_idle =
    {
      filename = "__Mobile-suit__/graphics/entity/dummy.png",
      priority = "high",
      line_length = 4,
      width = 1,
      height = 1,
      frame_count = 1,
      direction_count = 4,
      shift = {0, 0}
    },

    in_motion =
    {      filename = "__Earth-federation__/graphics/entity/flymanta/flymanta.png",      priority = "high",      line_length = 4,      width = 80,      height = 60,      frame_count = 1,      direction_count = 4,      shift = {0, 0}    },

    shadow_in_motion =
    {
      filename = "__Mobile-suit__/graphics/entity/dummy.png",
      priority = "high",
      line_length = 4,
      width = 1,
      height = 1,
      frame_count = 1,
      direction_count = 4,
      shift = {0, 0}
    }
  }

}
)
