
data:extend
(
{

  {

    type = "projectile",

    name = "ef-cannon-projectile",

    flags = {"not-on-map"},

    collision_box = {{-0.05, -1.1}, {0.05, 1.1}},

    acceleration = 0,

    action =

    {
      type = "direct",
      action_delivery =

      {

        type = "instant",

        target_effects =
        {

          {
            type = "damage",

            damage = { amount = 150 , type = "physical"}

          },

          {
            type = "damage",

            damage = { amount = 50 , type = "explosion"}

          }

        }

      }
    },

    final_action =
    {

      type = "direct",

      action_delivery =
      {

        type = "instant",

        target_effects =

        {

          {

            type = "create-entity",
            entity_name = "small-scorchmark",

            check_buildability = true

          }
        }
      }
    },

    animation =

    {
      filename = "__base__/graphics/entity/bullet/bullet.png",      frame_count = 1,      width = 3,      height = 50,      priority = "high"
    },

  },

  {

    type = "projectile",

    name = "white-base-projectile",

    flags = {"not-on-map"},

    acceleration = 0.05,

    action =
    {

      type = "direct",

      action_delivery =

      {

        type = "instant",

        target_effects =

        {

          type = "create-entity",

          entity_name = "core-booster",

          offsets = {{-1, -1},{1, 1}}


        },
      }

    },

    light = {intensity = 0.5, size = 4},

    animation =
    {
      filename = "__Earth-federation__/graphics/icons/core-booster.png",
      frame_count = 1,
      width = 32,
      height = 32,
      priority = "high"
    },

    shadow =
    {
      filename = "__Mobile-suit__/graphics/entity/dummy.png",
      frame_count = 1,
      width = 32,
      height = 32,
      priority = "high"
    },

    smoke = capsule_smoke

  },
  {

    type = "projectile",

    name = "efaf-base-projectile",

    flags = {"not-on-map"},

    acceleration = 0.05,

    action =
    {

      type = "direct",

      action_delivery =

      {

        type = "instant",

        target_effects =

        {

          type = "create-entity",

          entity_name = "flymanta",

          offsets = {{-1, 0},{0, -1},{1, 0},{0, 1}}

        },
      }

    },

    light = {intensity = 0.5, size = 4},

    animation =
    {
      filename = "__Earth-federation__/graphics/icons/flymanta.png",
      frame_count = 1,
      width = 32,
      height = 32,
      priority = "high"
    },

    shadow =
    {
      filename = "__Mobile-suit__/graphics/entity/dummy.png",
      frame_count = 1,
      width = 32,
      height = 32,
      priority = "high"
    },

    smoke = capsule_smoke

  }
}
)
